



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Nginx+Django搭建</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Nginx+Django搭建</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-11 13:17:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本机环境介绍</p>
<p>虚拟机操作系统版本如下</p>
<pre class="prettyprint linenums"><code>[root@node1 ~]# cat /etc/redhat-release<br />
CentOS Linux release 7.2.1511 (Core)<br />
</code></pre>
<p>IP地址为：<code>192.168.3.3/24</code><br /><br />
安装epel源</p>
<pre class="prettyprint linenums"><code>rpm -ivh http://mirrors.aliyun.com/epel/epel-release-latest-7.noarch.rpm<br />
# 或者<br />
wget -O /etc/yum.repos.d/epel.repo http://mirrors.aliyun.com/repo/epel-7.repo<br />
</code></pre>
<p>如果之前有epel源，需要先删除：</p>
<pre class="prettyprint linenums"><code>mv /etc/yum.repos.d/epel.repo /etc/yum.repos.d/epel.repo.backup<br />
mv /etc/yum.repos.d/epel-testing.repo /etc/yum.repos.d/epel-testing.repo.backup<br />
</code></pre>
<p>安装Nginx依赖包</p>
<pre class="prettyprint linenums"><code>yum install -y openssl-devel pcre-devel<br />
</code></pre>
<p>安装Nginx</p>
<pre class="prettyprint linenums"><code>[root@node1 /usr/local/src/nginx-1.10.2]# wget http://nginx.org/download/nginx-1.10.2.tar.gz<br />
[root@node1 /usr/local/src]# tar xf nginx-1.10.2.tar.gz<br />
[root@node1 /usr/local/src]# cd nginx-1.10.2/<br />
[root@node1 /usr/local/src/nginx-1.10.2]# ./configure<br />
[root@node1 /usr/local/src/nginx-1.10.2]# make &amp;&amp; make install<br />
</code></pre>
<p>修改nginx配置文件如下：</p>
<pre class="prettyprint linenums"><code>[root@EMMGTEST2 ~]# egrep -v '^$|#' /usr/local/nginx/conf/nginx.conf<br />
worker_processes  1;<br />
events {<br />
    worker_connections  1024;<br />
}<br />
http {<br />
    include       mime.types;<br />
    default_type  application/octet-stream;<br />
    sendfile        on;<br />
    keepalive_timeout  65;<br />
    gzip  on;<br />
    server {<br />
        listen       80;<br />
        server_name  deng t20.com;<br />
    access_log      /var/log/nginx/myweb_access.log;<br />
    error_log       /var/log/nginx/myweb_error.log;<br />
    location / {<br />
        include uwsgi_params;<br />
        uwsgi_pass 127.0.0.1:8000;<br />
        uwsgi_read_timeout 2;<br />
    }<br />
    location /static {<br />
        alias /application/django/mysite/static/;<br />
     }<br />
        error_page   500 502 503 504  /50x.html;<br />
        location = /50x.html {<br />
            root   html;<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p>创建nginx accesslog路径</p>
<pre class="prettyprint linenums"><code>[root@node1 /usr/local/src/nginx-1.10.2]# mkdir /var/log/nginx<br />
</code></pre>
<p>检查配置文件没有问题</p>
<pre class="prettyprint linenums"><code>[root@node1 /usr/local/src/nginx-1.10.2]# /usr/local/nginx/sbin/nginx -t<br />
nginx: the configuration file /usr/local/nginx/conf/nginx.conf syntax is ok<br />
nginx: configuration file /usr/local/nginx/conf/nginx.conf test is successful<br />
</code></pre>
<p>启动nginx</p>
<pre class="prettyprint linenums"><code>[root@node1 /usr/local/src/nginx-1.10.2]# /usr/local/nginx/sbin/nginx<br />
</code></pre>
<p>安装pip(python的安装程序)</p>
<pre class="prettyprint linenums"><code>wget https://bootstrap.pypa.io/get-pip.py<br />
python get-pip.py<br />
#当有多个版本的python时，要在特定的版本安装pip需要用那个版本的python执行get-pip.py, 比如在python2.6上安装pip：python2.6 get-pip.py<br />
</code></pre>
<p>安装uwsgi</p>
<pre class="prettyprint linenums"><code>pip install uwsgi<br />
</code></pre>
<p>安装django，版本不正确可能起不来,版本要和自己的电脑上的版本一致，要不会有问题。django在1.10的时候template还有session貌似都做过改动，</p>
<pre class="prettyprint linenums"><code>pip install django==1.9.8<br />
</code></pre>
<p>创建目录</p>
<pre class="prettyprint linenums"><code>mkdir /wis/django<br />
</code></pre>
<p>把mysite文件夹拷贝到django下面<br /><br />
确认uwsgi.ini配置文件没有问题：</p>
<pre class="prettyprint linenums"><code>[root@node1 /wis/django/mysite]# egrep -v '^$|#' uwsgi.ini<br />
[uwsgi]<br />
socket = :8000<br />
chdir           = /wis/django/mysite<br />
module          = mysite.wsgi<br />
master          = true<br />
processes       = 4<br />
vacuum          = true

[root@node1 /wis/django/mysite]# pwd<br />
/wis/django/mysite<br />
</code></pre>
<p>在当前目录启动uwsgi</p>
<pre class="prettyprint linenums"><code>[root@node1 /wis/django/mysite]#nohup uwsgi --ini uwsgi.ini &amp;<br />
</code></pre>
<p>一般生产中我们都是通过unix socket文件来传输，如下（socket属性）：</p>
<pre class="prettyprint linenums"><code>[root@v178 ~]# stat /run/mysite.socket<br />
  文件：&quot;/run/mysite.socket&quot;<br />
  大小：0               块：0          IO 块：4096   套接字<br />
设备：12h/18d   Inode：99694       硬链接：1<br />
权限：(0664/srw-rw-r--)  Uid：(    0/    root)   Gid：(  995/   nginx)<br />
最近访问：2017-05-15 08:55:58.154113380 +0800<br />
最近更改：2017-05-15 08:55:58.154113380 +0800<br />
最近改动：2017-05-15 08:55:58.154113380 +0800<br />
创建时间：-<br />
[root@v178 ~]# ll /run/mysite.socket<br />
srw-rw-r-- 1 root nginx 0 5月  15 08:55 /run/mysite.socket<br />
</code></pre>
<p>我们的uwsgi配置文件要修改如下：</p>
<pre class="prettyprint linenums"><code>[root@v178 moji]# cat uwsgi.ini |grep -v '#'<br />
[uwsgi]<br />
socket = /run/mysite.socket<br />
chdir           = /application/django/moji<br />
module          = moji.wsgi<br />
master          = true<br />
processes       = 4<br />
vacuum          = true<br />
chmod-socket = 664<br />
chown-socket = root:nginx<br />
</code></pre>
<p>nginx location配置如下：</p>
<pre class="prettyprint linenums"><code>location / {<br />
    include uwsgi_params;<br />
    uwsgi_pass unix:/run/mysite.socket;<br />
}<br />
</code></pre>
<p>本文没有做优化设置，要做进一步的了解，大家可以参考nginx官方文档了。<br /><br />
还有要说的是socket文件之所以放到/run下面是由于在/tmp下面有权限问题（开始放到tmp下面是没问题的，后来不知道为啥就不行了），和这个最后的t有关系，具体的就没仔细研究了</p>
<pre class="prettyprint linenums"><code>[root@v178 ~]# ls -ld /tmp<br />
drwxrwxrwt. 19 root root 4096 5月  15 09:17 /tmp</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93dv7g8.html">删除smartygit的配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93d2w08.html">openlayer 3 在layer上添加feature</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnyez28.html">linux 几个控制流语句的格式例子（if语句）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvyzm1q.html">使用linux的nc来进行文件的传输</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn11z6x8.html">&lpar;转载整理&rpar;SAP ERP常用T-CODE</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4jvmq.html">miniui datagrid 保存到服务端，使用&period;NET 自带 JSON 转换时发现日期格式不兼容。</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x736v8.html">Razor视图引擎布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x66xv8.html">Android Studio常用插件续</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv15om1q.html">Awesome Delphi</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j5wvv8.html">雅居乐在核心产品 &amp;amp&semi;quot&semi;决策&amp;amp&semi;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1xj3xq.html">一个最简单的cell按钮点击回调</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjepjx8.html">Cocos2D游戏项目CCTableView在Xcode7&period;2下的无法滚动问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jp41v8.html">Servlet  监听器Listner</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y0exn8.html">Keepalived配置文件详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwn7648.html">SpringBoot关于SpringDataJpa中findOne&lpar;&rpar;方法报错问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjpnr59.html">关于spring boot 的事务类型配置留存</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oelpx8.html">Android 官方Demo ActionBarCompat-Styled</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5we77q.html">Java SE和Java EE应用的性能调优</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj24209.html">scrapy 常用代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp1xke9.html">python3 的 round 函数的 练习</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnv4myg8.html">ASCS HA</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5kzk4q.html">关于163发邮件报错535 Error：authentication failed解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv4jgk8.html">记一个jquery 无缝轮播的制作方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv4j2l8.html">js：捕获冒泡和事件委托</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv4v338.html">Linux：sudo，没有找到有效的 sudoers 资源。</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wgpogq.html">简单定时器的Java实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllp1x0q.html">反射与特性与Tool编写</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw2mvk8.html">EOS 权限</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwr57v9.html">页面JS实现按钮点击增加输入框</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rkjgj9.html">sonar gitlab&plus;jenkins配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
